## ros-foxy-rmw 1.0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rmw)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)

find_package(rcutils REQUIRED)
find_package(rosidl_runtime_c REQUIRED)

include(cmake/configure_rmw_library.cmake)

set(rmw_sources
  "src/allocators.c"
  "src/convert_rcutils_ret_to_rmw_ret.c"
  "src/event.c"
  "src/init.c"
  "src/init_options.c"
  "src/message_sequence.c"
  "src/names_and_types.c"
  "src/publisher_options.c"
  "src/sanity_checks.c"
  "src/security_options.c"
  "src/subscription_options.c"
  "src/topic_endpoint_info_array.c"
  "src/topic_endpoint_info.c"
  "src/types.c"
  "src/validate_full_topic_name.c"
  "src/validate_namespace.c"
  "src/validate_node_name.c"
)
set_source_files_properties(${rmw_sources} PROPERTIES LANGUAGE "C")
add_library(${PROJECT_NAME} ${rmw_sources})
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")

if(BUILD_TESTING AND NOT RCUTILS_DISABLE_FAULT_INJECTION)
  target_compile_definitions(${PROJECT_NAME} PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
endif()

ament_target_dependencies(${PROJECT_NAME}
  "rcutils"
  "rosidl_runtime_c"
)
configure_rmw_library(${PROJECT_NAME} LANGUAGE "C")

ament_export_dependencies(
  rcutils
  rosidl_runtime_c
)
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_export_targets(${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
  # pass extra include dirs to cppcheck explicitly
  list(APPEND AMENT_LINT_AUTO_EXCLUDE ament_cmake_cppcheck)
  ament_cppcheck(INCLUDE_DIRS ${rcutils_INCLUDE_DIRS})

  add_subdirectory(test)
endif()

ament_export_development_version_if_higher_than_manifest("0.8.2-dev")
ament_package(CONFIG_EXTRAS "rmw-extras.cmake")

install(
  DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME}
)
install(
  DIRECTORY include/
  DESTINATION include
)
install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gmock REQUIRED)
find_package(osrf_testing_tools_cpp REQUIRED)


ament_add_gmock(test_allocators
  test_allocators.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_allocators)
  target_link_libraries(test_allocators ${PROJECT_NAME})
endif()

ament_add_gmock(test_convert_rcutils_ret_to_rmw_ret
  test_convert_rcutils_ret_to_rmw_ret.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_convert_rcutils_ret_to_rmw_ret)
  target_link_libraries(test_convert_rcutils_ret_to_rmw_ret ${PROJECT_NAME})
endif()

ament_add_gmock(test_event
  test_event.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_event)
  target_link_libraries(test_event ${PROJECT_NAME})
endif()

ament_add_gmock(test_init_options
  test_init_options.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_init_options)
  target_link_libraries(test_init_options ${PROJECT_NAME})
endif()

ament_add_gmock(test_init
  test_init.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_init)
  target_link_libraries(test_init ${PROJECT_NAME})
endif()

ament_add_gmock(test_message_sequence
  test_message_sequence.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_message_sequence)
  target_link_libraries(test_message_sequence ${PROJECT_NAME})
endif()

ament_add_gmock(test_names_and_types
  test_names_and_types.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_names_and_types)
  target_link_libraries(test_names_and_types ${PROJECT_NAME}
                        osrf_testing_tools_cpp::memory_tools)
endif()

ament_add_gmock(test_publisher_options
  test_publisher_options.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_publisher_options)
  target_link_libraries(test_publisher_options ${PROJECT_NAME})
endif()

ament_add_gmock(test_sanity_checks
  test_sanity_checks.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_sanity_checks)
  target_link_libraries(test_sanity_checks ${PROJECT_NAME})
endif()

ament_add_gmock(test_security_options
  test_security_options.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_security_options)
  target_link_libraries(test_security_options ${PROJECT_NAME})
endif()

ament_add_gmock(test_serialized_message
  test_serialized_message.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_serialized_message)
  target_link_libraries(test_serialized_message ${PROJECT_NAME})
  target_link_libraries(test_serialized_message osrf_testing_tools_cpp::memory_tools)
endif()

ament_add_gmock(test_subscription_options
  test_subscription_options.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_subscription_options)
  target_link_libraries(test_subscription_options ${PROJECT_NAME})
endif()

ament_add_gmock(test_types
  test_types.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_types)
  target_link_libraries(test_types ${PROJECT_NAME})
endif()

ament_add_gmock(test_validate_full_topic_name
  test_validate_full_topic_name.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_validate_full_topic_name)
  target_link_libraries(test_validate_full_topic_name ${PROJECT_NAME})
endif()

ament_add_gmock(test_validate_node_name
  test_validate_node_name.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_validate_node_name)
  target_link_libraries(test_validate_node_name ${PROJECT_NAME})
endif()

ament_add_gmock(test_validate_namespace
  test_validate_namespace.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_validate_namespace)
  target_link_libraries(test_validate_namespace ${PROJECT_NAME})
  if(UNIX AND NOT APPLE AND NOT ANDROID)
    target_link_libraries(test_validate_namespace pthread)
  endif()
  if(NOT WIN32)
    set_target_properties(test_validate_namespace PROPERTIES COMPILE_FLAGS "-std=c++14")
  endif()
endif()

ament_add_gmock(test_topic_endpoint_info_array
  test_topic_endpoint_info_array.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_topic_endpoint_info_array)
  target_link_libraries(test_topic_endpoint_info_array ${PROJECT_NAME}
  osrf_testing_tools_cpp::memory_tools)
endif()

ament_add_gmock(test_topic_endpoint_info
  test_topic_endpoint_info.cpp
  # Append the directory of librmw so it is found at test time.
  APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
)
if(TARGET test_topic_endpoint_info)
  target_link_libraries(test_topic_endpoint_info ${PROJECT_NAME}
  osrf_testing_tools_cpp::memory_tools)
endif()

=== debian/changelog ===
ros-foxy-rmw (1.0.4-1focal) focal; urgency=high

  * Correct parameter names to match documentation (#250 <https://github.com/ros2/rmw/issues/250>) (#322 <https://github.com/ros2/rmw/issues/322>)
  * Contributors: mergify[bot], Geoffrey Biggs

 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 16 Mar 2023 00:00:00 -0000

ros-foxy-rmw (1.0.3-1focal) focal; urgency=high

  * Update quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#306 <https://github.com/ros2/rmw/issues/306>)
  * Remove extra link (#292 <https://github.com/ros2/rmw/issues/292>)
  * Update QD to QL 1 (#291 <https://github.com/ros2/rmw/issues/291>)
  * Contributors: Alejandro Hernández Cordero, Simon Honigmann, Stephen Brawner

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 14 Apr 2021 00:00:00 -0000

ros-foxy-rmw (1.0.2-1focal) focal; urgency=high

  * Update service request/response API documentation. (#279 <https://github.com/ros2/rmw//issues/279>)
  * Update rmw_get_serialized_message_size docblock (#281 <https://github.com/ros2/rmw//issues/281>)
  * Update rmw_service_server_is_available doc (#280 <https://github.com/ros2/rmw//issues/280>)
  * Update wait and wait sets' API documentation. (#275 <https://github.com/ros2/rmw//issues/275>)
  * Update graph API documentation. (#272 <https://github.com/ros2/rmw//issues/272>)
  * Update service server/client creation/destruction API documentation. (#276 <https://github.com/ros2/rmw//issues/276>)
  * update rmw_*_*_allocation returns (#278 <https://github.com/ros2/rmw//issues/278>)
  * Update gid API documentation. (#274 <https://github.com/ros2/rmw//issues/274>)
    Namely, rmw_get_gid_for_publisher() and rmw_compare_gids_equal().
  * Update taking API documentation. (#271 <https://github.com/ros2/rmw//issues/271>)
  * Update publishing API documentation. (#270 <https://github.com/ros2/rmw//issues/270>)
  * Add fault injection macros for use in other packages (#254 <https://github.com/ros2/rmw//issues/254>)
    * Add fault injection macros for use in other packages
    * cxx/c flags
    * Address feedback
    * lint cmake
  * Add bad_alloc return to topic_endpoint_info functions (#269 <https://github.com/ros2/rmw//issues/269>)
  * Update publisher/subscription matched count API documentation. (#262 <https://github.com/ros2/rmw//issues/262>)
  * Update publisher/subscription QoS query API documentation. (#263 <https://github.com/ros2/rmw//issues/263>)
    Follow-up after 0176872b10ff502ae34fa3eef5e900145f18b0b3.
  * Extend rmw_serialized_message_t tests. (#261 <https://github.com/ros2/rmw//issues/261>)
  * Update serialization/deserialization API documentation. (#258 <https://github.com/ros2/rmw//issues/258>)
    * Update rmw_(de)serialize() API documentation.
    * Add rmw_serialize_message_t API documentation.
  * Update subscription API documentation (#256 <https://github.com/ros2/rmw//issues/256>)
    * Update subscription creation/destruction API documentation.
    * Update subscription QoS querying API documentation.
  * Update publisher creation/destruction API documentation. (#252 <https://github.com/ros2/rmw//issues/252>)
  * Update node creation/destruction API documentation. (#249 <https://github.com/ros2/rmw//issues/249>)
  * Require enclave upon rmw_init() call. (#247 <https://github.com/ros2/rmw//issues/247>)
  * Update init/shutdown API documentation. (#243 <https://github.com/ros2/rmw//issues/243>)
  * Update init options API documentation. (#244 <https://github.com/ros2/rmw//issues/244>)
  * remove double empty lines (#240 <https://github.com/ros2/rmw//issues/240>)
    as per title
  * Update QD
  * Rebasing and adding time_bomb_allocator
  * fix class name
  * Add test types
  * Increase rmw testing coverage
  * Handle zero-length names_and_types properly (#239 <https://github.com/ros2/rmw//issues/239>)
    from malloc(3):
  * Add unit tests for set_root_path
  * RMW_PUBLIC to security_options_set_root_path
  * Remove redundant check (#237 <https://github.com/ros2/rmw//issues/237>)
  * Do not link against pthread on Android (#259 <https://github.com/ros2/rmw//issues/259>) (#268 <https://github.com/ros2/rmw//issues/268>)
    Co-authored-by: Esteve Fernandez <mailto:esteve@apache.org>
  * Fix rmw_names_and_types_fini test to address issue #234 <https://github.com/ros2/rmw//issues/234> (#235 <https://github.com/ros2/rmw//issues/235>) (#265 <https://github.com/ros2/rmw//issues/265>)
    * Fix rmw_names_and_types_fini test to address issue #234 <https://github.com/ros2/rmw//issues/234>
    * Switch explicit size with variable
    * ASSERT_EQ
    Co-authored-by: brawner <mailto:brawner@gmail.com>
  * Add Security Vulnerability Policy pointing to REP-2006. (#230 <https://github.com/ros2/rmw//issues/230>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette, Jacob Perron, Karsten Knese, Michel Hidalgo, Scott K Logan, Stephen Brawner, brawner

 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 13 Oct 2020 00:00:00 -0000

ros-foxy-rmw (1.0.1-1focal) focal; urgency=high

  * Fix cppcheck error (#229 <https://github.com/ros2/rmw/issues/229>)
  * Update Quality Declaration to reflect 1.0 (#228 <https://github.com/ros2/rmw/issues/228>)
  * Contributors: Michel Hidalgo, Stephen Brawner

 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 19 May 2020 00:00:00 -0000

ros-foxy-rmw (1.0.0-1focal) focal; urgency=high

  * Remove MANUAL_BY_NODE liveliness API (#227 <https://github.com/ros2/rmw/issues/227>)
  * Improved Quality declarations (#225 <https://github.com/ros2/rmw/issues/225>)
  * Quality declarations for rmw and rmw_implementation_cmake (#205 <https://github.com/ros2/rmw/issues/205>)
  * Add tests for untested public functionality (#203 <https://github.com/ros2/rmw/issues/203>)
  * Contributors: Alejandro Hernández Cordero, Ivan Santiago Paunovic, Stephen Brawner

 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 12 May 2020 00:00:00 -0000

ros-foxy-rmw (0.9.0-1focal) focal; urgency=high



=== debian/control ===
Source: ros-foxy-rmw
Section: misc
Priority: optional
Maintainer: Dirk Thomas <dthomas@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake-gmock <!nocheck>, ros-foxy-ament-cmake-ros, ros-foxy-ament-cmake-version, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-osrf-testing-tools-cpp <!nocheck>, ros-foxy-rcutils, ros-foxy-rosidl-runtime-c, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rmw
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-rcutils, ros-foxy-rosidl-runtime-c, ros-foxy-ros-workspace
Description: Contains the ROS middleware API.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rmw//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
